﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace xamDataChart1
{
    /// <summary>
    /// Represents observable collection of data points 
    /// </summary>
    public class ObservableDataSource : ObservableCollection<ObservableDataPoint>
    {
        public ObservableDataSource()
        {
            this.Add(
                new ObservableDataPoint
                {
                    X = 3d,
                    Y = 5d
                });
        }
    }
    /// <summary>
    /// Represents observable data point 
    /// </summary>
    public class ObservableDataPoint : INotifyPropertyChanged
    {
        #region Porperties
        private double _x;
        private double _y;
        public double X
        {
            get { return _x; }
            set { if (_x == value) return; _x = value; this.OnPropertyChanged("X"); }
        }
        public double Y
        {
            get { return _y; }
            set { if (_y == value) return; _y = value; this.OnPropertyChanged("Y"); }
        }
        #endregion
        #region Event Handlers
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
        protected void OnPropertyChanged(PropertyChangedEventArgs propertyChangedEventArgs)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
                handler(this, propertyChangedEventArgs);
        }
        #endregion
    }
}
